'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : Joseph Saliba                                     *
'*  Notice  : Copyright (c) 2011 [select VIEW...EDITOR OPTIONS] *
'*          : All Rights Reserved                               *
'*  Date    : 25-05-11                                          *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
Device = 16F88

'________________________________________________________________________________________
'**** Added by Fuse Configurator ****
' Use the Fuse Configurator plug-in to change these settings

Declare Reminders Off
@ CONFIG_REQ = 0 ; Override Compiler's configuration settings
Asm-
__Config _Config1, 0x3F10 ;FOSC_INTOSCIO & WDTE_OFF & PWRTE_ON & MCLRE_OFF & BOREN_OFF & LVP_OFF & CPD_OFF & WRT_OFF & DEBUG_OFF & CCPMX_RB0 & CP_OFF 
__Config _Config2, 0x3FFD ;FCMEN_ON & IESO_OFF 
Endasm-
Declare Reminders On

'**** End of Fuse Configurator Settings ****
'________________________________________________________________________________________

OSCCON = %01101110          ' Internal frequency set at 4MHz

Xtal = 4                    ' Frequency running at 4MHz

'________________________________________________________________________________________

Dim Sample  As 15           ' Constant used for number of samples

Dim S_Bit   As Bit          ' Bit used as flag for setup routine
Dim S_Updt  As Bit          ' Bit used to servo update in ISR every 50Hz
Dim Gear_F  As Bit          ' Bit used to flag gear up or down position
Dim Upd_Req As Bit          ' Bit used to update requirements

Dim Mode    As Byte         ' Variable used for mode selection and green LED flash No.
Dim Time    As Byte         ' Variable used to hold Time value
Dim Loop    As Byte         ' Variable to hold number of loops within a For...Next
Dim Blink   As Byte         ' Variable to compare number of flash of green LED
Dim S_Time  As Byte         ' Variable used to exit setup, (Setup Time)
Dim Reverse As Byte         ' Variable used for reverse of canopy servo, 0 = Nor, 1 = Rev

Dim Rx_Raw  As Word         ' Variable used to hold raw value of receiver signal
Dim RX_Cnpy As Word         ' Variable used to hold canopy receiver signal
Dim RX_Gear As Word         ' Variable used to hold gear receiver signal
Dim Speed   As Word         ' Variable used to hold canopy speed
Dim Chl_Dif As Word         ' Variable to hold the difference between SH_Cnpy and SL_Cnpy
Dim T_CnpyM As Word         ' Variable to hold temporary value of canopy movement

Dim SL_Cnpy As Word         ' Variable to hold lowest value of servo canopy endpoint
Dim SH_Cnpy As Word         ' Variable to hold highest value of servo canopy endpoint
Dim SL_Lock As Word         ' Variable to hold lowest value of servo canopy lock endpoint
Dim SH_Lock As Word         ' Variable to hold lowest value of servo canopy lock endpoint
Dim CnPos_L As Word         ' Variable to hold value of canopy position lock 
Dim CnPos_M As Word         ' Variable to hold value of canopy movement

Dim Temp    As Word         ' Variable to hold various temporary values

'________________________________________________________________________________________

Dead_Code_Remove = 1        ' Remove dead code
Declare HIGHLOW_TRIS_REVERSE = On ' Handle the Read, Modify, Write differently

'________________________________________________________________________________________

CMCON = 7                   ' Turn OFF comparator
ANSEL = %00000000           ' Turn all pins to digital
ADCON1 = %10000000          ' Right justify result if analog is used

TRISA = %11100001           ' Configure PORTA inputs / outputs
TRISB = %00000110           ' Configure PORTB inputs / outputs
'________________________________________________________________________________________
'*****************
'DECLARE SYMBOLS *
'*****************

Symbol T0IF = INTCON.2      ' TMR0 Overflow Interrupt Flag
Symbol T0IE = INTCON.5      ' TMR0 Overflow Interrupt Enable
Symbol GIE  = INTCON.7      ' Global Interrupt Enable
Symbol PS0  = OPTION_REG.0  ' Prescaler Rate Select
Symbol PS1  = OPTION_REG.1  ' Prescaler Rate Select
Symbol PS2  = OPTION_REG.2  ' Prescaler Rate Select
Symbol PSA  = OPTION_REG.3  ' Prescaler Assignment
Symbol T0SE = OPTION_REG.4  ' TMR0 Source Edge Select bit
Symbol T0CS = OPTION_REG.5  ' TMR0 Clock Source Select bit
Symbol INTEDG = OPTION_REG.6' Interrupt Edge Select bit
Symbol RBPU = OPTION_REG.7  ' PORTB Pull-up Enable bit

'---------------------------------------------------------------------------------------
'*******************************
'* Define Input / Output PORTs *
'*******************************

Symbol Raw_Cnpy = PORTA.0   ' Canopy receiver signal
Symbol Test     = PORTA.1   ' Used for debbuging purposes
Symbol LED_Cnpy = PORTA.2   ' Canopy operating LED
Symbol LED_Gear = PORTA.3   ' Retract gear operating LED
Symbol LED_Set  = PORTA.4   ' Setup LED
Symbol Push_Set = PORTA.5   ' Push for setup purposes
Symbol Pr_Swit  = PORTA.6   ' Retract pressure switch
Symbol Raw_Gear = PORTA.7   ' Gear receiver signal

Symbol Push_Up  = PORTB.1   ' Push for selection of up menu
Symbol Push_Dn  = PORTB.2   ' Push for selection of down menu

Symbol Ret_VL   = PORTB.4   ' Retract valve
Symbol Gear_Out = PORTB.5   ' Output to gear servo out, (used if press. switch connected)
Symbol Cnp_Lock = PORTB.6   ' Output to canopy lock servo
Symbol Cnp_OpCL = PORTB.7   ' Output to open / close canopy servo

'________________________________________________________________________________________

PORTA = 0                   ' Turn OFF PORTA
PORTB = 0                   ' Turn OFF PORTB

'If ERead 0 > 0 Then         ' Check if it the first time that PIC is running this code.
 '   GoSub First_On          ' If yes, gosub First_On
  '      EndIf               ' End If...Then instruction


On_Interrupt ISR            'Where to go on an Interrupt

GoTo Over_ISR               'Jump over ISR
'________________________________________________________________________________________
'*********************
'* INTERRUPT ROUTINE *
'*********************

Int_Sub_Start               ' Marker for compiler to save SFR's before interrupt    
ISR:                        ' Interrupt Service Routine
Context Save                ' Save registers before continue ISR
TMR0 = 100                  ' Load an offset of 100 for TMR0 for a 100Hz interrupt

'----------------------------------------------------------------------------------------

If S_Bit = 1 Then           ' If S_Bit = 1 (set push is pressed) then 
    Inc S_Time              ' increase S_Time
    Else S_Time = 0         ' else if S_Bit = 0 then clear S_Time
EndIf                       ' End If...Then instruction






'----------------------------------------------------------------------------------------
' The following will switch ON and OFF RLed for 25ms 
' When Blink = Mode, there will be another 75ms OFF. This will determine Mode number
' Eg. ON-OFF-PAUSE = Mode 1,      ON-OFF-ON-PAUSE = Mode 2, etc...

If Mode > 0 Then Inc Time   ' Only if Mode is greater than 0 increase variable Time

If Mode > 0 And Time < 25 Then   ' If mode > 0 and Time < 25
    High LED_Set                 ' then switch ON Setup LED
        Else Low LED_Set         ' else turn OFF Setup LED 
            EndIf                ' End If...Then instruction

If Time = 50 Then           ' If Time = 50 then
    Time = 0                ' clear Time,
    Inc Blink               ' increase Blink
        EndIf               ' End If...Then instruction


If Blink = Mode Then        ' If Blink reaches mode then 
    Time = 51               ' load Time with 51
    Blink = 0               ' Clear Blink
        EndIf               ' End If...Then instruction


If Time = 125 Then Time = 0 ' If Time = 125 then Clear Time

Set_Skip:                   ' Setup skip label

'----------------------------------------------------------------------------------------

Clear T0IF        			' Clear TMR0 interrupt flag

Context Restore             ' END OF INTERRUPT ROUTINE
Int_Sub_End                 ' Marker for compiler to re-load SFR's after interrupt

'________________________________________________________________________________________
'*****************
'* SET REGISTERS *
'*****************
'Below is the prescaler setting you chose....

Over_ISR:

While GIE = 1 : GIE = 0 : Wend ' Disable interrupts before setting prescaler

PS0  = 1                    ' \                                                  
PS1  = 0                    '  \ Set the prescaler rate to 1:64                                                
PS2  = 1                    '  /                                                
PSA  = 0                    ' /                                                  
TMR0 = 100                  ' Load an offset of 100 for TMR0 for a 100Hz interrupt

RBPU = 1                    ' Disable internal pull-up
T0CS = 0			        ' Set the clock source for internal oscillator
T0IF = 0                    ' Clear the interrupt flag
T0IE = 1                    ' Enable tmr0 interrupt
GIE  = 1                    ' Enable Global interrupts

DelayMS 10                 ' Stabilize PIC at startup

'----------------------------------------------------------------------------------------

Blink   = 0                 ' Clear Blink
S_Bit   = 0                 ' Clear S_Bit
Gear_F  = 0                 ' Clear Gear_F
S_Time  = 0                 ' Clear S_Time, (Setup Time)
Upd_Req = 0                 ' Clear Upd_Req 

Test1:
Mode = 1
High Test
GoTo Test1
